﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework;

namespace TDDraw
{
    public class TextureManager
    {
        #region Singleton
        private static TextureManager instance;

        private TextureManager() { }

        public static TextureManager Instance
        {
            get
            {
                if (instance == null)
                {
                    instance = new TextureManager();
                }
                return instance;
            }
        }
        #endregion Singleton

        public Game Game { get; set; }

        // Tiles
        public Texture2D Tile_Lawn { get { return Game.Content.Load<Texture2D>(@"Tiles\green"); } }
        public Texture2D Tile_Water { get { return Game.Content.Load<Texture2D>(@"Tiles\blue"); } }
        public Texture2D Tile_Lane { get { return Game.Content.Load<Texture2D>(@"Tiles\grey"); } }

        // Fonts
        public SpriteFont Font_Debug { get { return Game.Content.Load<SpriteFont>(@"Fonts\Calibri_12_Bold"); } }
    }
}
