using System;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;
using Little_Tower_Defense.Controller;


namespace Little_Tower_Defense
{

    public class GUI_UI : Microsoft.Xna.Framework.DrawableGameComponent, IClickable
    {
        public Color BackGroundColor { set; get; }
        public Rectangle Area { set; get; }
        
        private SpriteFont Calibri;
        private Texture2D BackGround;
        private Game game;
        private Rectangle area;
        private SpriteBatch spriteBatch;
        // Debug Area
        private float frameRate;
        private float elapsed;
        private float frames;

        public GUI_UI(Game game, Rectangle area)
            : base(game)
        {
            this.game = game;
            this.area = area;
        }

        public override void Initialize()
        {
            this.BackGroundColor = Color.Gray;
            this.DrawOrder = 2;
            this.Visible = true;
            spriteBatch = new SpriteBatch(Game.GraphicsDevice);
            this.Area = new Rectangle((game.GraphicsDevice.PresentationParameters.BackBufferWidth - 250), 0, 250, game.GraphicsDevice.PresentationParameters.BackBufferHeight);
            base.Initialize(); 
        }

        protected override void LoadContent()
        {
            this.Calibri = Game.Content.Load<SpriteFont>("UIElements\\Calibri_12_Bold");
            this.BackGround = Game.Content.Load<Texture2D>("UIElements\\Background");
        }

        public override void Update(GameTime gameTime)
        {

            base.Update(gameTime);
        }

        public override void Draw(GameTime gameTime)
        {
            if (this.Visible == true)
            {
                spriteBatch.Begin();
                spriteBatch.Draw(BackGround, this.Area, this.BackGroundColor);
                spriteBatch.DrawString(Calibri, "Men", new Vector2(Area.X + 20, Area.Y + 20), Color.Black);

                // Frames per seconds
                elapsed += (float)gameTime.ElapsedGameTime.TotalSeconds;

                if (elapsed > 1.0f)
                {
                    frameRate = frames;
                    elapsed -= 1.0f;
                    frames = 0;
                }
                else
                {
                    frames += 1;
                }

                spriteBatch.DrawString(Calibri, frameRate.ToString(), new Vector2(Area.X + 80, Area.Y + 20), Color.Black);
                spriteBatch.End();
                
            

            }
        }

        void IClickable.Click(MouseState state) 
        {
            //ToDo Clicked Event
        }

        void IClickable.Release()
        { 
            // TODO
        }

        public Rectangle GetArea()
        {
            return(this.Area);
        }
    }
}
