﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Little_Tower_Defense.Controller;
using Little_Tower_Defense.Interfaces;
using Little_Tower_Defense.Utilitys;

namespace Little_Tower_Defense
{
    /// <summary>
    /// A component to pann a level while holding down the left mouse button.
    /// </summary>
    class ArrowKeysPanning : GameComponent
    {
        public new LittleTowerDefense Game;

        private MouseState leftButtonDownMouseState;
        private bool isLeftMouseButtonDown;
        private Level level;

        public ArrowKeysPanning(LittleTowerDefense game)
            : base(game)
        {
            this.Game = game;
        }

        public override void Initialize()
        {
            base.Initialize();

            searchNeededComponents();
            isLeftMouseButtonDown = false;
        }

        private void searchNeededComponents()
        {
            try
            {
                this.level = (Level)Game.Components.First(a => a is Level);
            }
            catch (NullReferenceException)
            {
                // this is ok, maybe the component will be added later ..
                Logger.WriteLog("ComponentNotFound", "A LeftmouseButtonPanning Instance searched for a Level Instance.");
            }
        }

        public override void Update(GameTime gameTime)
        {
            KeyboardState asd = Keyboard.GetState();
            if (Game.IsActive == true)
            {
                if (asd.IsKeyDown(Keys.Left))
                {
                    try
                    {
                        level.OffsetX -= 1;
                    }
                    catch (NullReferenceException)
                    {
                        searchNeededComponents();
                    }
                }
                if (asd.IsKeyDown(Keys.Right))
                {
                    try
                    {
                        level.OffsetX += 1;
                    }
                    catch (NullReferenceException)
                    {
                        searchNeededComponents();
                    }
                }
                if (asd.IsKeyDown(Keys.Down))
                {
                    try
                    {
                        level.OffsetY += 1;
                    }
                    catch (NullReferenceException)
                    {
                        searchNeededComponents();
                    }
                }
                if (asd.IsKeyDown(Keys.Up))
                {
                    try
                    {
                        level.OffsetY -= 1;
                    }
                    catch (NullReferenceException)
                    {
                        searchNeededComponents();
                    }
                }
            }
        }
    }
}
